﻿using Syncfusion.UI.Xaml.Controls.Input;
using Syncfusion.UI.Xaml.Schedule;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Globalization;
using System.IO;
using System.Linq;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace ScheduleContextMenuOverrided_WinRT
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        SfCalendar monthCalendar;
        YearCalendar yearCalendar;
        internal DateTime currentDate = DateTime.Now.Date;
        Flyout calendarFlyout;
        DateTime moveToDate;

        public MainPage()
        {
            this.InitializeComponent();
            this.schedule1.Loaded += schedule1_Loaded;
        }

        void schedule1_Loaded(object sender, RoutedEventArgs e)
        {
            calendarFlyout = (this.schedule1.FindElementOfType<Button>()).Flyout as Flyout;

            if (calendarFlyout != null && schedule1!=null)
                calendarFlyout.Hide();
        }

        public void monthcalendar_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if (monthCalendar != null)
            {
                ChangeScheduleDate((DateTime)monthCalendar.SelectedDate);
            }


        }

        private void ChangeScheduleDate(DateTime date)
        {
            moveToDate = date;
            if (schedule1 == null)
                schedule1 = this.FindParentElementOfType<SfSchedule>();
            if (schedule1 != null && calendarFlyout!=null)
            {
                schedule1.MoveToDate(date);
                calendarFlyout.Hide();
            }
                
        }

        private void PART_CurrentDay_Click(object sender, RoutedEventArgs e)
        {
            this.schedule1.MoveToDate(DateTime.Now.Date);

            if (calendarFlyout != null)
                calendarFlyout.Hide();      
        }

        private void Sample_MonthCalendar_Loaded(object sender, RoutedEventArgs e)
        {
            monthCalendar = sender as SfCalendar;
            var weekDaysGrid = monthCalendar.FindElementOfTypeWithName<Grid>("PART_WeekDaysGrid");
            if (weekDaysGrid != null)
            {
                for (int i = 0; i < weekDaysGrid.Children.Count; i++)
                {
                    var textBlock = weekDaysGrid.Children[i] as TextBlock;
                    if (textBlock != null)
                        textBlock.Text = DateTimeFormatInfo.CurrentInfo.AbbreviatedDayNames[i];
                }
            }
            if (monthCalendar != null)
            {
                monthCalendar.SelectionChanged += monthcalendar_SelectionChanged;
            }



        }

        private void yearCalendar_SelectedMonthChanged(object sender, SelectedMonthChangedEventArgs e)
        {

            if (yearCalendar != null)
            {
                int day = (schedule1.VisibleDates != null && schedule1.VisibleDates.Count > 0 &&
                            DateTime.DaysInMonth(yearCalendar.SelectedYear, yearCalendar.SelectedMonth) >= schedule1.VisibleDates[0].Day) ?
                            schedule1.VisibleDates[0].Day : 1;
                ChangeScheduleDate(new DateTime(yearCalendar.SelectedYear, yearCalendar.SelectedMonth, day));
            }

        }

        private void YearCalendar_Loaded(object sender, RoutedEventArgs e)
        {
            yearCalendar = sender as YearCalendar;
            if (yearCalendar != null)
            {
                yearCalendar.SelectedMonthChanged += yearCalendar_SelectedMonthChanged;
            }
        }

        private void Grid_PointerReleased(object sender, PointerRoutedEventArgs e)
        {
            if (calendarFlyout != null)
                calendarFlyout.Hide();  
        }
    }

    public class DateTimeConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, string language)
        {
            CultureInfo currentCulture = CultureInfo.CurrentCulture;
            var selectedDates = (ObservableCollection<DateTime>)value;
            if (selectedDates == null || selectedDates.Count <= 0)
            {
                return null;
            }
            var firstDate = selectedDates.OrderByDescending(x => x).Last();
            var lastDate = selectedDates.OrderByDescending(x => x).First();
            string result;
            if (selectedDates.Count <= 7)
            {
                if (firstDate.Month == lastDate.Month && firstDate.Year == lastDate.Year)
                    result = currentCulture.DateTimeFormat.GetMonthName(currentCulture.Calendar.GetMonth(firstDate)) + ", " + lastDate.Year;
                else if (firstDate.Year == lastDate.Year)
                    result = currentCulture.DateTimeFormat.GetMonthName(currentCulture.Calendar.GetMonth(firstDate)) + " - " + currentCulture.DateTimeFormat.GetMonthName(currentCulture.Calendar.GetMonth(lastDate)) + ", " + lastDate.Year;
                else
                    result = currentCulture.DateTimeFormat.GetMonthName(currentCulture.Calendar.GetMonth(firstDate)) + " " + firstDate.Year + " - " + currentCulture.DateTimeFormat.GetMonthName(currentCulture.Calendar.GetMonth(lastDate)) + ", " + lastDate.Year;
            }
            else
            {
                var month = currentCulture.DateTimeFormat.GetMonthName(currentCulture.Calendar.GetMonth(selectedDates[selectedDates.Count / 2].Date));
                result = month + ", " + selectedDates[selectedDates.Count / 2].Year;
            }
            return result;
        }

        public object ConvertBack(object value, Type targetType, object parameter, string language)
        {
            return null;
        }

    }


    #region booltovisibilityConverter

    /// <summary>
    /// Represents a converter that converts boolean values to and from visibility enumeration values. 
    /// </summary>
    public class booltovisibilityConverter : IValueConverter
    {
        /// <summary>
        /// Converts a boolean value to a visibility enumeration value.
        /// </summary>

        public object Convert(object value, Type targetType, object parameter, string culture)
        {
            if (parameter != null && parameter.ToString() == "Inverse")
            {
                return (value is bool && (bool)value) ? Visibility.Collapsed : Visibility.Visible;
            }
            return (value is bool && (bool)value) ? Visibility.Visible : Visibility.Collapsed;
        }

        /// <summary>
        /// Converts a visibility enumeration value to boolean value.
        /// </summary>

        public object ConvertBack(object value, Type targetType, object parameter, string culture)
        {
            if (parameter != null && parameter.ToString() == "Inverse")
            {
                return value is Visibility && (Visibility)value == Visibility.Collapsed;
            }
            return value is Visibility && (Visibility)value == Visibility.Visible;
        }


    }

    #endregion

    public static class DependencyObjectExtensions
    {
        public static T FindParentElementOfType<T>(this FrameworkElement element) where T : class
        {
            var correctlyTyped = element as T;
            if (correctlyTyped != null)
            {
                return correctlyTyped;
            }

            if (element != null)
            {
                var parent = element.Parent ?? VisualTreeHelper.GetParent(element);
                var p1 = FindParentElementOfType<T>(parent as FrameworkElement);
                if (p1 != null)
                {
                    return p1;
                }
            }
            return null;
        }

        /// <summary>
        ///     Searches the sub tree of an element (including that element) 
        ///     for an element of a particular type.
        /// </summary>
        public static T FindElementOfType<T>(this FrameworkElement element) where T : FrameworkElement
        {
            var correctlyTyped = element as T;
            if (correctlyTyped != null)
            {
                return correctlyTyped;
            }

            if (element != null)
            {
                int numChildren = VisualTreeHelper.GetChildrenCount(element);
                for (int i = 0; i < numChildren; i++)
                {
                    var child = FindElementOfType<T>(VisualTreeHelper.GetChild(element, i) as FrameworkElement);
                    if (child != null)
                    {
                        return child;
                    }
                }

                // Popup continue in another window, jump to that tree
                var popup = element as Popup;
                if (popup != null)
                {
                    return FindElementOfType<T>(popup.Child as FrameworkElement);
                }
            }

            return null;
        }
        /// <summary>
        ///     Searches the sub tree of an element (including that element) 
        ///     for an element of a particular type.
        /// </summary>
        internal static T FindElementOfTypeWithName<T>(this FrameworkElement element, string name) where T : FrameworkElement
        {
            var correctlyTyped = element as T;
            if (correctlyTyped != null && element.Name.Contains(name))
            {
                return correctlyTyped;
            }

            if (element != null)
            {
                int numChildren = VisualTreeHelper.GetChildrenCount(element);
                for (int i = 0; i < numChildren; i++)
                {
                    var child = FindElementOfTypeWithName<T>(VisualTreeHelper.GetChild(element, i) as FrameworkElement, name);
                    if (child != null)
                    {
                        return child;
                    }
                }

                // Popup continue in another window, jump to that tree
                var popup = element as Popup;
                if (popup != null)
                {
                    return FindElementOfTypeWithName<T>(popup.Child as FrameworkElement, name);
                }
            }

            return null;
        }

    }




}
